<?php


namespace app\admin\controller;
use app\BaseController;
use think\App;
use think\facade\Cache;
use think\facade\Db;
use think\facade\Response;
use think\helper\Arr;


class Stat extends BaseController{
	public function __construct(App $app) {parent::__construct($app);}

	public function stats(){
		 $data=Cache::get("statContent");

		 return app_show(0,"获取成功",$data);
	}

	public function depart(){
		 $data=Cache::get("departContent");
		 return app_show(0,"获取成功",$data);
	}
	public function total(){
		$list =Db::name("total_tips")->where("year",date("Y"))->column("depart_id,depart_ment,tips,month,year,total,th_total,profit,rate,prate");
		$data=[
			[
				"depart_ment"=>'总计',
				"content"=>[
					1=>["tips"=>0,"month"=>1,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					2=>["tips"=>0,"month"=>2,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					3=>["tips"=>0,"month"=>3,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					4=>["tips"=>0,"month"=>4,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					5=>["tips"=>0,"month"=>5,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					6=>["tips"=>0,"month"=>6,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					7=>["tips"=>0,"month"=>7,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					8=>["tips"=>0,"month"=>8,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					9=>["tips"=>0,"month"=>9,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					10=>["tips"=>0,"month"=>10,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					11=>["tips"=>0,"month"=>11,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],
					12=>["tips"=>0,"month"=>12,"year"=>date("Y"),"total"=>0,"th_total"=>0,"profit"=>0,"rate"=>0,"prate"=>0],

				]
			]
		];
		foreach ($list as $value){
			$temp=["tips"=>$value['tips'],"month"=>$value['month'],"year"=>date("Y"),"total"=>$value['total'],"th_total"=>$value['th_total'],"profit"=>$value['profit'],"rate"=>$value['rate'],"prate"=>$value['prate']];
			$data[0]['content'][$value['month']]["tips"]+=$value['tips'];
			$data[0]['content'][$value['month']]["total"]+=$value['total'];
			$data[0]['content'][$value['month']]["th_total"]+=$value['th_total'];
			$data[0]['content'][$value['month']]["profit"]=$data[0]['content'][$value['month']]["total"] - $data[0]['content'][$value['month']]["th_total"];
			$data[0]['content'][$value['month']]["rate"]=round($data[0]['content'][$value['month']]["total"]/$data[0]['content'][$value['month']]["tips"] *100,2);
			$data[0]['content'][$value['month']]["prate"]=round($data[0]['content'][$value['month']]["profit"]/$data[0]['content'][$value['month']]["tips"] *100,2);
			if (isset($data[$value['depart_id']])){
				$data[$value['depart_id']]['content'][$value['month']]= $temp;
			}else{
				$data[$value['depart_id']]["depart_ment"]=$value['depart_ment'];
				$data[$value['depart_id']]['content'][$value['month']]= $temp;
			}
		}
		return app_show(0,"获取成功",$data);
	}

	public  function departEveryDay(){
		$post = $this->request->only(["daytime"=>date("Y-m-d H:i:s")],"post","trim");

		$depart_tips = Db::connect("mysql_wsm3.0")->name("depart_tips")
		->where("year",date("Y",strtotime($post["daytime"])))
		->where("month",date("m",strtotime($post["daytime"])))
		->select();
		if($depart_tips->isEmpty()){
			return error_show(1004,"未获取到各部门指标");
		}
		$return=[];
		$everyday =Db::name("depart_everyday")
		             ->where("day_time",date("Y-m-d",strtotime($post["daytime"])))
		             ->where("companyNo","GS2203161855277894")
		             ->column("sale_total,th_total,zy_sale_total,channel_sale_total","depart_id");
		$everymonth =Db::name("depart_everyday")
		             ->whereBetween("day_time",[date("Y-m-01",strtotime($post["daytime"])),date("Y-m-t",  strtotime($post["daytime"]))])
		             ->where("companyNo","GS2203161855277894")
			->group("depart_id")
		             ->column("sum(sale_total) as msale_total,sum(th_total) as mth_total,sum(zy_sale_total) as mzy_sale_total,sum(channel_sale_total) as mchannel_sale_total,depart_id","depart_id");
		foreach ($depart_tips as $value){
			$temp=[];
			$temp["depart"] = $value['depart_item'];
			$temp["total_tips"] = $value['total_tips'];
			$temp["sale_total"] =isset($everyday[$value['depart_id']])?$everyday[$value['depart_id']]['sale_total']:0;
			$temp["zy_sale_total"] =isset($everyday[$value['depart_id']])?$everyday[$value['depart_id']]['zy_sale_total']:0;
			$temp["channel_sale_total"] =isset($everyday[$value['depart_id']])?$everyday[$value['depart_id']]['channel_sale_total']:0;
			$temp["th_total"] =isset($everyday[$value['depart_id']])?$everyday[$value['depart_id']]['th_total']:0;
			$temp["msale_total"] =isset($everymonth[$value['depart_id']])?$everymonth[$value['depart_id']]['msale_total']:0;
			$temp["mth_total"] = isset($everymonth[$value['depart_id']])?$everymonth[$value['depart_id']]['mth_total']:0;
			$temp["mchannel_sale_total"] = isset($everymonth[$value['depart_id']])?$everymonth[$value['depart_id']]['mchannel_sale_total']:0;
			$temp["mzy_sale_total"] = isset($everymonth[$value['depart_id']])?$everymonth[$value['depart_id']]['mzy_sale_total']:0;
			$return[]=$temp;
		}
		return app_show(0,"获取成功",$return);
	}

	public  function companyEveryMonth(){
		$post = $this->request->only(["daytime"=>date("Y-m-d H:i:s"),"companyNo"=>''],"post","trim");
		$where=[];
		if($post['companyNo']!='') $where=["companyNo"=>$post['companyNo']];
		$depart_tips = Db::name("depart_tips")
		                 ->where("year",date("Y",strtotime($post["daytime"])))
		                 ->where("month",date("m",strtotime($post["daytime"])))
						->where($where)
		                 ->column("*","companyNo");
		if(empty($depart_tips)){
			return error_show(1004,"未获取到各部门指标");
		}
		$return=[];
		$sort=["GS2302231125079621",'GS2302231323386950','GS2304031312553746','GS2302231124114965','GS2203161855277894'];
		foreach ($sort as $value){
			$temp=[];
			if(isset($depart_tips[$value])){
				$temp["companyName"] = $depart_tips[$value]['companyName'];
				$temp["total_tips"] = $depart_tips[$value]['total_tips'];
				$temp["dayinfo"] =Db::name("depart_company")
				                    ->where("day_time",date("Y-m-d",strtotime($post["daytime"])))
				                    ->where(["companyNo"=>$value])
				                    ->column("sale_total,th_total,type,companyNo");;
				$temp["monthinfo"] =Db::name("depart_company")
				                      ->whereBetween("day_time",[date("Y-m-01",strtotime($post["daytime"])),date("Y-m-t",  strtotime($post["daytime"]))])
				                      ->where(["companyNo"=>$value])
				                      ->group("companyNo,type")
				                      ->column("sum(sale_total) as msale_total,sum(th_total) as mth_total,companyNo,type");
				$return[]=$temp;
			}

		}
		//1.北京百辰荣达国际科贸有限公司
		//2.北京泓源广诚国际商贸有限公司
		//3.北京锦兴弘昌科技有限公司
		//4.北京普润心堂商贸有限公司
		//5.北京万宇恒通国际科贸有限公司
//		$sort=["GS2302231125079621",'GS2302231323386950','GS2304031312553746','GS2302231124114965','GS2203161855277894'];

		return app_show(0,"获取成功",$return);
	}
}